/*
 * This file is part of the Poliqarp suite.
 * 
 * Copyright (C) 2004-2009 by Instytut Podstaw Informatyki Polskiej
 * Akademii Nauk (IPI PAN; Institute of Computer Science, Polish
 * Academy of Sciences; cf. www.ipipan.waw.pl).  All rights reserved.
 * 
 * This file may be distributed and/or modified under the terms of the
 * GNU General Public License version 2 as published by the Free Software
 * Foundation and appearing in the file gpl.txt included in the packaging
 * of this file.  (See http://www.gnu.org/licenses/translations.html for
 * unofficial translations.)
 * 
 * A commercial license is available from IPI PAN (contact
 * Michal.Ciesiolka@ipipan.waw.pl or ipi@ipipan.waw.pl for more
 * information).  Licensees holding a valid commercial license from IPI
 * PAN may use this file in accordance with that license.
 * 
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 */

#ifndef HAVE_LISP_STREAM_H
#define HAVE_LISP_STREAM_H

struct lisp_stream;

#include "lisp.h"

struct lisp_stream
{
   int (*read) (struct lisp_stream *);
   int (*peek) (struct lisp_stream *);
   void (*close) (struct lisp_stream *);
   void (*unget) (struct lisp_stream *, int c);
   int unget_char;
};

void make_stream(lisp_env *, struct lisp_stream *);

void lisp_stream_unget(struct lisp_stream *, int c);

int lisp_stream_peek(struct lisp_stream *);

#endif
