/*
 * This file is part of the Poliqarp suite.
 * 
 * Copyright (C) 2004-2009 by Instytut Podstaw Informatyki Polskiej
 * Akademii Nauk (IPI PAN; Institute of Computer Science, Polish
 * Academy of Sciences; cf. www.ipipan.waw.pl).  All rights reserved.
 * 
 * This file may be distributed and/or modified under the terms of the
 * GNU General Public License version 2 as published by the Free Software
 * Foundation and appearing in the file gpl.txt included in the packaging
 * of this file.  (See http://www.gnu.org/licenses/translations.html for
 * unofficial translations.)
 * 
 * A commercial license is available from IPI PAN (contact
 * Michal.Ciesiolka@ipipan.waw.pl or ipi@ipipan.waw.pl for more
 * information).  Licensees holding a valid commercial license from IPI
 * PAN may use this file in accordance with that license.
 * 
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 */

#include "lisp-string-stream.h"

struct lisp_stream *make_string_stream(struct lisp_env *env,
   const char *string)
{
   struct lisp_stream *ls;
   struct lisp_string_stream *lss;

   ls = malloc(sizeof *ls + sizeof *lss);
   make_stream(env, ls);
   lss = (void *) (((char *) ls) + sizeof *ls);

   ls->read = lisp_string_stream_read;
   ls->close = lisp_string_stream_close;

   lss->buff = string;
   lss->end = string + strlen(string);
   lss->curr = string;

   return ls;
}

int lisp_string_stream_read(struct lisp_stream *ls)
{
   struct lisp_string_stream *lss;
   if (ls->unget_char != -1) {
      int c = ls->unget_char;
      ls->unget_char = -1;
      return c;
   }
   lss = (void *) (((char *) ls) + sizeof *ls);
   return lss->curr < lss->end ? *lss->curr++ : -1;
}

void lisp_string_stream_close(struct lisp_stream *ls)
{
   free(ls);
}
