/*
 * This file is part of the Poliqarp suite.
 * 
 * Copyright (C) 2004-2009 by Instytut Podstaw Informatyki Polskiej
 * Akademii Nauk (IPI PAN; Institute of Computer Science, Polish
 * Academy of Sciences; cf. www.ipipan.waw.pl).  All rights reserved.
 * 
 * This file may be distributed and/or modified under the terms of the
 * GNU General Public License version 2 as published by the Free Software
 * Foundation and appearing in the file gpl.txt included in the packaging
 * of this file.  (See http://www.gnu.org/licenses/translations.html for
 * unofficial translations.)
 * 
 * A commercial license is available from IPI PAN (contact
 * Michal.Ciesiolka@ipipan.waw.pl or ipi@ipipan.waw.pl for more
 * information).  Licensees holding a valid commercial license from IPI
 * PAN may use this file in accordance with that license.
 * 
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 */

#ifndef UTILS_H
#define UTILS_H

#include <poliqarp-config.h>

#include <stdio.h>

#include <foostring/foostring.h>

/** Returns the substring of TEXT without whitespaces on the start and end. */
char *text_trim(const char *text);

char *text_normalize(const char *text);

/** 
 * Opens the file for binary reading or writing, checking whether the
 * operation was successful and bailing out with a fatal error if it
 * wasn't.
 *
 * @param fname the name of the file to open
 * @param write if true, the file shall be opened for writing,
 *    else for reading.
 */
FILE *xfopen(const char *fname, bool write);


/**
 * Break pathname string into directory and filename components.
 */
void split_pathname(const string_t path, string_t *dirname, string_t *basename);

#endif /* UTILS_H */

