/*
 * This file is part of the Poliqarp suite.
 * 
 * Copyright (C) 2008-2009 by Instytut Podstaw Informatyki Polskiej
 * Akademii Nauk (IPI PAN; Institute of Computer Science, Polish
 * Academy of Sciences; cf. www.ipipan.waw.pl).  All rights reserved.
 * 
 * This file may be distributed and/or modified under the terms of the
 * GNU General Public License version 2 as published by the Free Software
 * Foundation and appearing in the file gpl.txt included in the packaging
 * of this file.  (See http://www.gnu.org/licenses/translations.html for
 * unofficial translations.)
 * 
 * A commercial license is available from IPI PAN (contact
 * Michal.Ciesiolka@ipipan.waw.pl or ipi@ipipan.waw.pl for more
 * information).  Licensees holding a valid commercial license from IPI
 * PAN may use this file in accordance with that license.
 * 
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 */

#ifndef BP_IO_H
#define BP_IO_H

#include <poliqarp-config.h>

#include <stdio.h>

#include <foostring/foostring.h>

FILE *bp_open(const string_t path, const char *mode);

void bp_close(FILE *fp);

void bp_truncate(FILE *fp, off64_t length);

void bp_try_unlink(const string_t path);

void bp_unlink(const string_t path);

void bp_rename(const string_t old, const string_t new);

size_t bp_read(FILE *fp, void *ptr, size_t size, size_t nmemb);

size_t bp_write(FILE *stream, void *ptr, size_t size, size_t nmemb);

#endif
