/*
 * This file is part of the Poliqarp suite.
 * 
 * Copyright (C) 2009 by Instytut Podstaw Informatyki Polskiej
 * Akademii Nauk (IPI PAN; Institute of Computer Science, Polish
 * Academy of Sciences; cf. www.ipipan.waw.pl).  All rights reserved.
 * 
 * This file may be distributed and/or modified under the terms of the
 * GNU General Public License version 2 as published by the Free Software
 * Foundation and appearing in the file gpl.txt included in the packaging
 * of this file.  (See http://www.gnu.org/licenses/translations.html for
 * unofficial translations.)
 * 
 * A commercial license is available from IPI PAN (contact
 * Michal.Ciesiolka@ipipan.waw.pl or ipi@ipipan.waw.pl for more
 * information).  Licensees holding a valid commercial license from IPI
 * PAN may use this file in accordance with that license.
 * 
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 */

#include <string.h>

#include <bp/common.h>
#include <bp/ng/xmlns-item.h>

struct xmlns_item *xmlns_item_new(const char *prefix, const char *uri)
{
   struct xmlns_item *this = bp_malloc(sizeof *this);
   this->prefix = bp_strdup(prefix);
   this->uri = bp_strdup(uri);
   return this;
}

void xmlns_item_destroy(struct xmlns_item *this)
{
   free(this->prefix);
   free(this->uri);
   this->prefix = NULL;
   this->uri = NULL;
}

void xmlns_item_free(void *this)
{
   xmlns_item_destroy(this);
   free(this);
}

