/*
 * This file is part of the Poliqarp suite.
 * 
 * Copyright (C) 2009 by Instytut Podstaw Informatyki Polskiej
 * Akademii Nauk (IPI PAN; Institute of Computer Science, Polish
 * Academy of Sciences; cf. www.ipipan.waw.pl).  All rights reserved.
 * 
 * This file may be distributed and/or modified under the terms of the
 * GNU General Public License version 2 as published by the Free Software
 * Foundation and appearing in the file gpl.txt included in the packaging
 * of this file.  (See http://www.gnu.org/licenses/translations.html for
 * unofficial translations.)
 * 
 * A commercial license is available from IPI PAN (contact
 * Michal.Ciesiolka@ipipan.waw.pl or ipi@ipipan.waw.pl for more
 * information).  Licensees holding a valid commercial license from IPI
 * PAN may use this file in accordance with that license.
 * 
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 */

#ifndef BPNG_XMLNS_ITEM_H
#define BPNG_XMLNS_ITEM_H 1

/**
 * A namespace declaration, i.e. a prefix-URI pair.
 */
struct xmlns_item {
   char *prefix;
   char *uri;
};

/**
 * Allocate memory for a namespace declaration. Then, initialize it.
 */
struct xmlns_item *xmlns_item_new(const char *prefix, const char *uri);

/**
 * Destroy the namespace declaration.
 */
void xmlns_item_destroy(struct xmlns_item *);

/**
 * Destroy the namespace declaration and free the allocated memory.
 */
void xmlns_item_free(void *);

#endif
