; Written by DJ, with the help of the HM NIS Edit Script Wizard.

; If neither of these is !define'd, a standalone installer will be produced.
; !define IPIPAN_CD ; Define for the installer of CD version.
; !define IPIPAN_DVD ; ...or DVD version.

!ifdef IPIPAN_DVD
!define IPIPAN_CD
!endif

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "Poliqarp"
!define PRODUCT_VERSION "1.3.13"
!define PRODUCT_PUBLISHER "IPI PAN"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define PRODUCT_STARTMENU_REGVAL "NSIS:StartMenuDir"
!define MUI_HEADERIMAGE_BITMAP "logo.bmp"
!define MUI_HEADERIMAGE
!define MUI_CUSTOMFUNCTION_GUIINIT Initialization
!define MUI_FINISHPAGE_NOAUTOCLOSE

SetCompressor lzma

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

Var JAVAFOUND
Var JAVADIR

!ifdef IPIPAN_CD
Var CORPUS_SAMPLE
!ifdef IPIPAN_DVD
Var CORPUS_ALL
!endif
!endif

Function Initialization
  Call AssertAdmin
  Call GetJava
  StrCmp $JAVAFOUND 't' end
  StrCmp $JAVAFOUND 'o' tooold nojava
tooold:
  MessageBox MB_YESNO $(TEXT_NOJAVAFOUND) IDYES +2 IDNO +1
  Abort
  Goto end
nojava:
  MessageBox MB_YESNO $(TEXT_JAVA2OLD) IDYES +2 IDNO +1
  Abort
  Goto end
end:
FunctionEnd

!ifdef IPIPAN_CD
Function StrRep
  ;Written by dirtydingus 2003-02-20 04:30:09
  ; USAGE
  ;Push String to do replacement in (haystack)
  ;Push String to replace (needle)
  ;Push Replacement
  ;Call StrRep
  ;Pop $R0 result	

  Exch $R4 ; $R4 = Replacement String
  Exch
  Exch $R3 ; $R3 = String to replace (needle)
  Exch 2
  Exch $R1 ; $R1 = String to do replacement in (haystack)
  Push $R2 ; Replaced haystack
  Push $R5 ; Len (needle)
  Push $R6 ; len (haystack)
  Push $R7 ; Scratch reg
  StrCpy $R2 ""
  StrLen $R5 $R3
  StrLen $R6 $R1
loop:
  StrCpy $R7 $R1 $R5
  StrCmp $R7 $R3 found
  StrCpy $R7 $R1 1 ; - optimization can be removed if U know len needle=1
  StrCpy $R2 "$R2$R7"
  StrCpy $R1 $R1 $R6 1
  StrCmp $R1 "" done loop
found:
  StrCpy $R2 "$R2$R4"
  StrCpy $R1 $R1 $R6 $R5
  StrCmp $R1 "" done loop
done:
  StrCpy $R3 $R2
  Pop $R7
  Pop $R6
  Pop $R5
  Pop $R2
  Pop $R1
  Pop $R4
  Exch $R3
	
FunctionEnd
!endif

Function ValidateJavaVersion
  Push $R0
  Push $R1
  Push $R2
  Push $R3
  StrCmp $JAVAFOUND 't' end
  StrCpy $R3 $R0
  ReadRegStr $R2 HKLM $R3 "CurrentVersion"
  IfErrors wrong
  StrCpy $R0 $R2 1 0
  StrCpy $R1 $R2 1 2
  IntCmp $R0 1 minor tooold right
minor:
  IntCmp $R1 5 right tooold right
wrong:
  StrCpy $JAVAFOUND 'n'
  Goto end
tooold:
  StrCpy $JAVAFOUND 'o'
  Goto end
right:
  ReadRegStr $JAVADIR HKLM "$R3\$R2" "JavaHome"
  StrCpy $JAVAFOUND 't'
end:
  Pop $R3
  Pop $R2
  Pop $R1
  Pop $R0
FunctionEnd

Function GetJava
  Push $R0
  Push $R1
  ClearErrors
  StrCpy $R0 "SOFTWARE\JavaSoft\Java Runtime Environment"
  Call ValidateJavaVersion
  StrCpy $R0 "SOFTWARE\JavaSoft\Java Development Kit"
  Call ValidateJavaVersion
  Pop $R1
  Pop $R0
FunctionEnd

Function AssertAdmin
  Push $R0
  UserInfo::GetAccountType
  IfErrors aa_end
  Pop $R0
  StrCmp $R0 "Admin" aa_end
  MessageBox MB_ICONEXCLAMATION $(TEXT_ADMIN)
  Abort
aa_end:
  Pop $R0
FunctionEnd

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!define MUI_LICENSEPAGE_RADIOBUTTONS
!ifdef IPIPAN_CD
!insertmacro MUI_PAGE_LICENSE "copying.txt"
!else
!insertmacro MUI_PAGE_LICENSE "gpl.txt"
!endif

; Components page
!insertmacro MUI_PAGE_COMPONENTS
; Directory page
!insertmacro MUI_PAGE_DIRECTORY

; Start menu page
var ICONS_GROUP
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "Poliqarp"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "${PRODUCT_STARTMENU_REGVAL}"
!insertmacro MUI_PAGE_STARTMENU Application $ICONS_GROUP
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "Polish"
!insertmacro MUI_LANGUAGE "English"

; Reserve files
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS
!insertmacro MUI_RESERVEFILE_LANGDLL

Function .onInit
  !insertmacro MUI_LANGDLL_DISPLAY
FunctionEnd

LangString DESC_SEC01 ${LANG_ENGLISH} "Files necessary for Poliqarp to operate."
LangString DESC_SEC01 ${LANG_POLISH} "Pliki niezbdne do dziaania programu Poliqarp."
!ifdef IPIPAN_CD
LangString DESC_SEC02 ${LANG_ENGLISH} "Files containing the IPI PAN corpus sample."
LangString DESC_SEC02 ${LANG_POLISH} "Pliki zawierajce prbk korpusu IPI PAN."
!ifdef IPIPAN_DVD
LangString DESC_SEC025 ${LANG_ENGLISH} "Files containing the IPI PAN corpus."
LangString DESC_SEC025 ${LANG_POLISH} "Pliki zawierajce korpus IPI PAN."
!endif
!endif
LangString DESC_SEC03 ${LANG_ENGLISH} "Create a shortcut on your desktop for Poliqarp."
LangString DESC_SEC03 ${LANG_POLISH} "Utwrz skrt na pulpicie dla Poliqarpa."
LangString SHORTCUTS ${LANG_ENGLISH} "Shortcuts"
LangString SHORTCUTS ${LANG_POLISH} "Skrty"
!ifdef IPIPAN_CD
LangString SAMPLENAME ${LANG_ENGLISH} "The IPI PAN Corpus sample"
LangString SAMPLENAME ${LANG_POLISH} "Prbka korpusu IPI PAN"
LangString SHORTCUTNAME ${LANG_ENGLISH} "The IPI PAN Corpus"
LangString SHORTCUTNAME ${LANG_POLISH} "Korpus IPI PAN"
!else
LangString SHORTCUTNAME ${LANG_ENGLISH} "Poliqarp"
LangString SHORTCUTNAME ${LANG_POLISH} "Poliqarp"
!endif
LangString SHORTCUTNAME2 ${LANG_ENGLISH} "The IPI PAN Corpus online"
LangString SHORTCUTNAME2 ${LANG_POLISH} "Strona WWW korpusu IPI PAN"

LangString TEXT_ADMIN ${LANG_POLISH} "Poliqarp moe by zainstalowany tylko przez administratora."
LangString TEXT_NOJAVAFOUND ${LANG_POLISH} "Instalator nie mg odnale informacji o zainstalowanej Javie w wersji co najmniej 5.0 w rejestrze tego komputera. Kontynuowanie instalacji spowoduje, e po jej zakoczeniu uruchomi si instalator Javy.$\n$\nCzy kontynuowa instalacj?"
LangString TEXT_JAVA2OLD ${LANG_POLISH} "Znaleziono star wersj Javy. Musisz uaktualni Jav, aby mc uywa Poliqarpa. Kontynuowanie instalacji spowoduje, e po jej zakoczeniu uruchomi si instalator Javy.$\n$\nCzy kontynuowa instalacj?"
LangString TEXT_LANG ${LANG_POLISH} "Polish"
LangString TEXT_CORPUSFOUND ${LANG_POLISH} "Znaleziono zainstalowany korpus IPI PAN. Czy na pewno chcesz zastpi istniejce pliki?"
LangString TEXT_ADMIN ${LANG_ENGLISH} "You need administrator privileges to install Poliqarp."
LangString TEXT_NOJAVAFOUND ${LANG_ENGLISH} "The installer could not find information in this computer's registry about installed Java (at least version 5.0). Continuing installation will cause the installer to launch Java installer afterwards.$\n$\nDo you wish to proceed with the installation?"
LangString TEXT_JAVA2OLD ${LANG_ENGLISH} "An old version of Java has been found. You must update Java in order for Poliqarp to work properly. Continuing installation will cause the installer to launch Java installer afterwards.$\n$\nDo you wish to proceed with the installation?"
LangString TEXT_LANG ${LANG_ENGLISH} "English"
LangString TEXT_CORPUSFOUND ${LANG_ENGLISH} "The IPI PAN Corpus files have been found in the installation directory. Do you wish to replace them?"

LangString PRODUCT_WEB_SITE ${LANG_POLISH} "http://korpus.pl/pl"
LangString PRODUCT_WEB_SITE ${LANG_ENGLISH} "http://korpus.pl/en"

LangString UN_PRE ${LANG_POLISH} "Czy na pewno chcesz usun program $(^Name) i wszystkie jego komponenty?"
LangString UN_PRE ${LANG_ENGLISH} "Are you sure you wish to remove $(^Name) and all its components from your system?"
LangString UN_POST ${LANG_POLISH} "Program $(^Name) zosta pomylnie usunity."
LangString UN_POST ${LANG_ENGLISH} "$(^Name) has been successfully removed."

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "Setup.exe"

InstallDir "$PROGRAMFILES\Poliqarp"
InstallDirRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString"
ShowInstDetails show
ShowUnInstDetails show

Section "Poliqarp" SEC01
  SetShellVarContext all
  SetOverwrite ifnewer
  SectionIn RO

  ; Delete remaining files after old version
  RMDir /R "$INSTDIR\graphics"
  RMDir /R "$INSTDIR\doc"
  Delete "$INSTDIR\*.exe"
  Delete "$INSTDIR\*.dll"
  Delete "$INSTDIR\*.jar"
  Delete "$INSTDIR\poliqarp.cfg"
  Delete "$INSTDIR\.poliqarp.cfg"
  Delete "$INSTDIR\poliqarp.his"
  Delete "$INSTDIR\.poliqarp.his"
  Delete "$INSTDIR\java.dir"
  ; Delete "$INSTDIR\corpus\*.*"
  Delete "$SMPROGRAMS\$ICONS_GROUP\*.lnk"
  Delete '$DESKTOP\Korpus IPI PAN.lnk'
  Delete '$DESKTOP\The IPI PAN Corpus.lnk'

  SetOutPath "$INSTDIR"
  File "poliqarp\*.exe"
  File "poliqarp\*.dll"
  File "poliqarp\*.jar"
  SetOutPath "$INSTDIR\doc"
  File /R "poliqarp\doc\"
SectionEnd

!ifdef IPIPAN_CD
Section $(SAMPLENAME) SEC02
  AddSize 361721
  CreateDirectory "$INSTDIR\corpora\2.sample.30"
  StrCpy $CORPUS_SAMPLE "t"
  ExecWait '"$EXEDIR\unzip.exe" -o "$EXEDIR\..\corpus\2.sample.30.zip" -d "$INSTDIR\corpora\2.sample.30"'
SectionEnd

!ifdef IPIPAN_DVD
Section $(SHORTCUTNAME) SEC025
  AddSize 2824365
  CreateDirectory "$INSTDIR\corpus\2.all.250"
  StrCpy $CORPUS_ALL "t"
  ExecWait '"$EXEDIR\unzip.exe" -o "$EXEDIR\..\corpus\2.all.250.zip" -d "$INSTDIR\corpora\2.all.250"'
SectionEnd
!endif
!endif

Section $(SHORTCUTS) SEC03
  SetShellVarContext all
  SetOutPath $INSTDIR
  CreateShortCut "$DESKTOP\$(SHORTCUTNAME).lnk" "$INSTDIR\Poliqarp.exe"
SectionEnd

Section -AdditionalIcons
  SetShellVarContext all
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "$(PRODUCT_WEB_SITE)"
  CreateDirectory "$SMPROGRAMS\$ICONS_GROUP"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Poliqarp.lnk" "$INSTDIR\poliqarp.exe"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\$(SHORTCUTNAME2).lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Function WriteConfigFile
  Push $R0
  Push $R1
  Push $R2

  FileOpen $R0 "$INSTDIR\.poliqarp.cfg" w
  Push 0
  Pop $R2
!ifdef IPIPAN_CD
  StrCmp $CORPUS_SAMPLE 't' +2
  Goto no_sample
  Push "$INSTDIR\corpora\2.sample.30\sample"
  Push "\"
  Push "\\"
  Call StrRep
  Pop $R1
  FileWrite $R0 'set mru_$R2 "$R1"$\n'
  IntOp $R2 $R2 + 1

no_sample:
!ifdef IPIPAN_DVD
  StrCmp $CORPUS_ALL 't' +2
  Goto no_all
  Push "$INSTDIR\corpora\2.all.250\all"
  Push "\"
  Push "\\"
  Call StrRep
  Pop $R1
  FileWrite $R0 'set mru_$R2 "$R1"$\n'

no_all:
!endif
!endif
  FileWrite $R0 'set language "$(TEXT_LANG)"$\n'
  FileClose $R0

  Pop $R2
  Pop $R1
  Pop $R0
FunctionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  Call WriteConfigFile
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "${PRODUCT_STARTMENU_REGVAL}" "$ICONS_GROUP"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "$(PRODUCT_WEB_SITE)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
  StrCmp $JAVAFOUND 't' goon
  ExecWait "$EXEDIR\java\setup.exe"
goon:
SectionEnd

; Section descriptions
!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC01} $(DESC_SEC01)
!ifdef IPIPAN_CD
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC02} $(DESC_SEC02)
!ifdef IPIPAN_DVD
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC025} $(DESC_SEC025)
!endif
!endif
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03} $(DESC_SEC03)
!insertmacro MUI_FUNCTION_DESCRIPTION_END

Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK $(UN_POST)
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 $(UN_PRE) IDYES +2
  Abort
FunctionEnd

Section Uninstall
  SetShellVarContext all
  ReadRegStr $ICONS_GROUP ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "${PRODUCT_STARTMENU_REGVAL}"
  Delete "$SMPROGRAMS\$ICONS_GROUP\*.lnk"

  Delete "$DESKTOP\$(SHORTCUTNAME).lnk"

  RMDir "$SMPROGRAMS\$ICONS_GROUP"
  RMDir /R "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  SetAutoClose true
SectionEnd
