/*
 * This file is part of the Poliqarp suite.
 * 
 * Copyright (C) 2004-2009 by Instytut Podstaw Informatyki Polskiej
 * Akademii Nauk (IPI PAN; Institute of Computer Science, Polish
 * Academy of Sciences; cf. www.ipipan.waw.pl).  All rights reserved.
 * 
 * This file may be distributed and/or modified under the terms of the
 * GNU General Public License version 2 as published by the Free Software
 * Foundation and appearing in the file gpl.txt included in the packaging
 * of this file.  (See http://www.gnu.org/licenses/translations.html for
 * unofficial translations.)
 * 
 * A commercial license is available from IPI PAN (contact
 * Michal.Ciesiolka@ipipan.waw.pl or ipi@ipipan.waw.pl for more
 * information).  Licensees holding a valid commercial license from IPI
 * PAN may use this file in accordance with that license.
 * 
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 */

package ipipan.poliqarp.logic;

import java.util.Locale;

import ipipan.poliqarp.connection.Message;
import ipipan.poliqarp.connection.PoliqarpConnection;

/**
 * The undefined metadata value.
 */
public class MetaDataValueUndefined extends MetaDataValue
{
   /**
    * Constructs this value from its string representation.
    * @param description description of the value
    */
   public MetaDataValueUndefined(String description)
   {
      super(description);
   }
   
   /**
    * Returns the representation of this metadata value as a string.
    * A locale can be helpful when converting several types of data
    * to strings, so this method takes one as a parameter.
    */
   public String toString(Locale locale)
   {
// AP:
//       return "[undefined]";
      return "";
   }
}
